// Generated by CoffeeScript 1.12.7
var barcodeScanListener;

barcodeScanListener = require('barcode-scan-listener');


/*
Listen for scan with specified product prefix.
@param [Function] onScan - callback to call when scan is successful. Passes the scanned string.
@param [String] prefix - character prefix that appears before the scanned string (e.g. 'P%', 'C%')
@param [RegExp] scanOptions.barcodeValueTest - RegExp defining valid scan value (not including prefix).
@param [Boolean] [scanOptions.finishScanOnMatch] - if true, test scan value (not including prefix)
  match with barcodeValueTest on each character. If matched, immediately
  call the scanHandler with the value. This will generally make scans faster.
 */

module.exports = angular.module('barcodeListener', []).directive('barcodeListener', function() {
  return {
    restrict: 'EA',
    scope: {
      onScan: '=',
      prefix: '@',
      valueTest: '@',
      finishScanOnMatch: '@',
      scanDuration: '@?'
    },
    link: function(scope, element, attrs) {
      var removeScanListener, scanDuration;
      scanDuration = +scope.scanDuration || 50;
      removeScanListener = barcodeScanListener.onScan({
        barcodePrefix: scope.prefix,
        barcodeValueTest: scope.valueTest ? new RegExp(scope.valueTest) : void 0,
        finishScanOnMatch: scope.finishScanOnMatch ? scope.finishScanOnMatch === 'true' : void 0,
        scanDuration: scanDuration
      }, scope.onScan);
      return element.on('$destroy', removeScanListener);
    }
  };
});
